## debian-installer 20141002

=== build/Makefile ===
#!/usr/bin/make -f
#
# Debian Installer system makefile.
# Copyright 2001-2003 by Joey Hess <joeyh@debian.org> and the d-i team.
# Licensed under the terms of the GPL.
#
# This makefile builds a debian-installer system and bootable images from 
# a collection of udebs which it downloads from a Debian archive. See
# README for details.
#
#
# General layout of our build directory hierarchy
#
# build/config/[<subarch>/][<medium>/][<flavour>/]<leaf-config>
# build/tmp/[<subarch>/][<medium>/][<flavour>/]<build-area>
# build/dest/[<subarch>/][<medium>/][<flavour>-]<images>
#
# Items in brackets can be left out if they are superfluous.
#
# These following <image> names are conventional.
#
# For small changeable media (floppies and the like):
# - boot.img, root.img, driver.img
#
# For single bootable images (e.g. tftp boot images):
# - boot.img
#
# For compressed single bootable images (harddisk or hd emulation):
# - boot.img.gz
#
# If those are not bootable:
# - root.img.gz
#
# Raw kernel images:
# - vmlinux or vmlinuz
#
# Example:
#
# dest/
# |-- cdrom-boot.img
# |-- floppy
# |   |-- access
# |   |   |-- boot.img
# |   |   |-- drivers.img
# |   |   `-- root.img
# |   |-- boot.img
# |   |-- cd-drivers.img
# |   |-- net-drivers.img
# |   `-- root.img
# |-- hd-media-boot.img.gz
# `-- netboot
#     |-- initrd.gz
#     `-- vmlinuz
#

# Add to PATH so dpkg will always work, and so local programs will be found.
PATH := util:$(PATH):/usr/sbin:/sbin
EATMYDATA = $(shell which eatmydata 2>/dev/null)
GZIP = $(shell which pigz gzip | head -1)

# We don't want this to be run each time we re-enter.
ifndef DEB_HOST_ARCH
DEB_HOST_ARCH = $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_ARCH_OS = $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
DEB_HOST_GNU_CPU = $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)
DEB_HOST_GNU_SYSTEM = $(shell dpkg-architecture -qDEB_HOST_GNU_SYSTEM)
DEB_HOST_MULTIARCH = $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
export DEB_HOST_ARCH DEB_HOST_ARCH_OS DEB_HOST_GNU_CPU DEB_HOST_GNU_SYSTEM DEB_HOST_MULTIARCH
endif

define drop_lang
	@echo "Dropping languages: $(1)"
	@set -e; \
	for FILE in $$(find $(TREE)/var/lib/dpkg -name "*.templates"); do \
		perl -e 'my $$status=0; my $$drop=shift; while (<>) { if (/^[A-Z]/ || /^$$/) { if (/^(Choices|Description|Indices|Default)-($$drop)/ && ! /^Choices-C:/) { $$status = 0 } else { $$status = 1 } } print if ($$status); }' $(1) < $$FILE > temp; \
		mv temp $$FILE; \
	done
endef

# We loop over all needed combinations of ARCH, SUBARCH, MEDIUM, FLAVOUR
# via recursive make calls. ARCH is constant, we don't support
# crosscompiling.
ARCH = $(DEB_HOST_ARCH)

# By default, we just advertise what we can do.
.PHONY: all
all: list

# Globally useful variables.
targetstring = $(patsubst _%,%,$(if $(SUBARCH),_$(SUBARCH),)$(if $(MEDIUM),_$(MEDIUM),)$(if $(FLAVOUR),_$(FLAVOUR),))
targetdirs = $(subst _,/,$(targetstring))

# Overridden in config/hurd.cfg
define genext2fs
  genext2fs -d $(TREE) -b `expr $$(du -s $(TREE) | cut -f 1) + $$(expr $$(find $(TREE) | wc -l) \* 2)` -m 0
endef

# Configurations for the varying ARCH, SUBARCH, MEDIUM, FLAVOUR.
# For simplicity, we use a similiar tree layout for config/, tmp/
# and dest/.
#
# Cheap trick: if one of the variables isn't defined, we run in
# a non-existing file and ignore it.
include config/common
include config/dir
-include config/$(ARCH).cfg
-include config/$(ARCH)/$(SUBARCH).cfg
-include config/$(ARCH)/$(SUBARCH)/$(MEDIUM).cfg
-include config/$(ARCH)/$(SUBARCH)/$(MEDIUM)/$(FLAVOUR).cfg
-include config/local

export KEYRING
export KERNELVERSION
export LOCALUDEBDIR

ifneq ($(shell id -u),0)
  ROOTCMD ?= fakeroot
endif

# Useful command sequences
define submake
  $(ROOTCMD) $(MAKE) --no-print-directory -j1
endef

define recurse_once
  @set -e; $(submake) $(1)_$(2)
endef

define recurse_many
  @set -e; $(foreach var,$($(1)_SUPPORTED) $(if $(RECURSE_EXTRA),$($(1)_SUPPORTED_EXTRA)),$(submake) $(2)_$(3) $(1)=$(var);)
endef

define recurse
  $(if $($(1)_SUPPORTED)$(if $(RECURSE_EXTRA),$($(1)_SUPPORTED_EXTRA)),$(call recurse_many,$(1),$(2),$(3)),$(call recurse_once,$(2),$(3)))
endef

define mkinitramfs
  (cd $(TREE) && find . | sort | cpio --quiet -o -H newc) > 
endef

# Limit on mfsroot size. It is determined by NKPT (in <machine/pmap.h).
# On amd64, it can be increased by increasing this variable.  On i386,
# this is a hard limit due to constraints of 4 GiB VM space.
ifeq ($(DEB_HOST_ARCH),kfreebsd-i386)
MFSROOT_LIMIT := 42m
else ifeq ($(DEB_HOST_ARCH),kfreebsd-amd64)
MFSROOT_LIMIT := 72m
endif

define mkfs.ufs1
  sh -c 'makefs -t ffs -s $(MFSROOT_LIMIT) -f 3000 -o minfree=0,version=1 $$0 ${TREE}'
endef

define e2fsck
  e2fsck -fy
endef

# Define MKFS_JFFS2 in the config file for your target.
# For example: MKFS_JFFS2 = mkfs.jffs2 -f -p -b -e 0x20000
define mkjffs2
  $(MKFS_JFFS2) -d $(TREE) -o
endef

# A generic recursion rule
.PHONY: all_%
all_%:
	@install -d $(STAMPS)
	$(call recurse,SUBARCH,subarch,$*)

.PHONY: subarch_%
subarch_%:
	$(call recurse,MEDIUM,medium,$*)

.PHONY: medium_%
medium_%:
	$(call recurse,FLAVOUR,flavour,$*)

.PHONY: flavour_%
flavour_%:
	$(if $(targetstring),@$(submake) _$*)

# Validate a targetstring, echo env variables for valid ones
.PHONY: validate_%
validate_%:
	@set -e; \
	SUBARCH= var='$(subst _, ,$(subst validate_,,$@))'; \
	tmp=$$(echo $$var |sed 's/[ ].*$$//'); \
	[ -z '$(SUBARCH_SUPPORTED)$(SUBARCH_SUPPORTED_EXTRA)' ] || [ -z "$$tmp" ] || [ -z "$$(echo $(SUBARCH_SUPPORTED) $(SUBARCH_SUPPORTED_EXTRA) |grep -w $$tmp)" ] || SUBARCH=$$tmp; \
	$(submake) medium_validate SUBARCH=$$SUBARCH var="$$var"

.PHONY: medium_validate
medium_validate:
	@set -e; \
	MEDIUM= var="$(strip $(patsubst $(SUBARCH)%,%,$(var)))"; \
	tmp=$$(echo $$var |sed 's/[ ].*$$//'); \
	[ -z '$(MEDIUM_SUPPORTED)$(MEDIUM_SUPPORTED_EXTRA)' ] || [ -z "$$tmp" ] || [ -z "$$(echo $(MEDIUM_SUPPORTED) $(MEDIUM_SUPPORTED_EXTRA) |grep -w $$tmp)" ] || MEDIUM=$$tmp; \
	$(submake) flavour_validate MEDIUM=$$MEDIUM var="$$var"

.PHONY: flavour_validate
flavour_validate:
	@set -e; \
	FLAVOUR= var="$(strip $(patsubst $(MEDIUM)%,%,$(var)))"; \
	tmp=$$(echo $$var |sed 's/[ ].*$$//'); \
	[ -z '$(FLAVOUR_SUPPORTED)$(FLAVOUR_SUPPORTED_EXTRA)' ] || [ -z "$$tmp" ] || [ -z "$$(echo $(FLAVOUR_SUPPORTED) $(FLAVOUR_SUPPORTED_EXTRA) | grep -w $$tmp)" ] || FLAVOUR=$$tmp; \
	$(submake) finish_validate FLAVOUR=$$FLAVOUR var="$$var"

.PHONY: finish_validate
finish_validate:
	@set -e; \
	var="$(strip $(patsubst $(FLAVOUR)%,%,$(var)))"; \
	if [ -z "$$var" ]; then \
		echo SUBARCH=$$SUBARCH MEDIUM=$$MEDIUM FLAVOUR=$$FLAVOUR; \
	else \
		echo SUBARCH= MEDIUM= FLAVOUR=; \
	fi;


# List all targets useful for direct invocation.
.PHONY: list
list:
	@echo "Useful targets:"
	@echo
	@echo "list"
	@echo "all_build"
	@echo "all_rebuild"
	@echo "stats"
	@echo "all_clean"
	@echo "reallyclean"
	@echo
	@$(submake) all_list RECURSE_EXTRA=1

.PHONY: _list
_list:
	@set -e; \
	echo build_$(targetstring); \
	echo stats_$(targetstring); \
	$(if $(findstring $(MEDIUM),$(WRITE_MEDIA)),echo write_$(targetstring);) \
	echo clean_$(targetstring); \
	echo rebuild_$(targetstring); \
	echo demo_$(targetstring); \
	echo shell_$(targetstring); \
	echo uml_$(targetstring); \
	echo qemu_$(targetstring); \
	echo


# Clean all targets.
.PHONY: reallyclean
reallyclean: all_clean
	for png in $(shell awk -F= '/^SPLASH_PNG=/ {print $$2}' config/*.cfg); do if [ -f $${png%%.png}.svg ]; then rm -f $$png; fi; done
	rm -rf $(APTDIR) $(APTDIR).udeb $(APTDIR).deb $(BASE_DEST) $(BASE_TMP) $(SOURCEDIR) $(DEBUGUDEBDIR)
	rm -f sources.list sources.list.udeb $(LOCALUDEBDIR)/Packages.gz $(LOCALUDEBDIR)/Packages
	rm -rf $(UDEBDIR) $(STAMPS)

# For manual invocation, we provide a generic clean rule.
.PHONY: clean_%
clean_%:
	@$(submake) _clean $(shell $(submake) $(subst clean_,validate_,$@))
	update-manifest

# The general clean rule.
.PHONY: _clean
_clean: tree_umount
	@[ -n "$(SUBARCH) $(MEDIUM) $(FLAVOUR)" ] || { echo "invalid target"; false; }
	-rm -f $(STAMPS)tree-unpack-$(targetstring)-stamp $(STAMPS)tree-$(targetstring)-stamp $(STAMPS)extra-$(targetstring)-stamp $(STAMPS)get_udebs-$(targetstring)-stamp
	rm -f $(TEMP)/diskusage.txt
	rm -f $(TEMP)/all.utf
	rm -f $(TEMP)/unifont.bdf $(TREE)/lib/unifont.bgf
	rm -f pkg-lists/standard-udebs pkg-lists/kernel-module-udebs
	rm -rf $(TARGET)
	rm -rf $(TEMP)

# all_build is provided automagically, but for manual invocation
# we provide a generic build rule.
.PHONY: build_%
build_%:
	@install -d $(STAMPS)
	@$(submake) _build $(shell $(submake) $(subst build_,validate_,$@))

# The general build rule.
.PHONY: _build
_build:
	@[ -n "$(SUBARCH) $(MEDIUM) $(FLAVOUR)" ] || { echo "invalid target"; false; }
	@$(submake) tree_umount $(EXTRATARGETS) $(TARGET)

# Convenience rules to clean and build.
.PHONY: rebuild_%
rebuild_%:
	@$(submake) clean_$(subst rebuild_,,$@) build_$(subst rebuild_,,$@)

.PHONY: _rebuild
_rebuild:
	@$(submake) _clean _build

# Run before releasing built files.
release:
	egrep '^[[:space:]]' $(BASE_DEST)/MANIFEST.udebs | \
		sed 's/^[[:space:]]*//' | sort | uniq > $(BASE_DEST)/udeb.list
	rm -f $(BASE_DEST)/MD5SUMS $(BASE_DEST)/SHA256SUMS
	cd $(BASE_DEST) && md5sum `find -L . -type f | sort` > MD5SUMS # XXX remove this
	cd $(BASE_DEST) && sha256sum `find -L . -type f | sort` > SHA256SUMS

# The general tree target.
$(STAMPS)tree-unpack-$(targetstring)-stamp: $(STAMPS)get_udebs-$(targetstring)-stamp
	dh_testroot
	@[ -d ../debian ] || { echo "directory '../debian' not found; complete source of 'debian-installer' package is required"; false; }
	cd .. && dpkg-checkbuilddeps
	@rm -f $@

	# This build cannot be restarted, because dpkg gets confused.
	rm -rf $(TREE)
	# Set up the basic files [u]dpkg needs.
	mkdir -p $(DPKGDIR)/info
	touch $(DPKGDIR)/status
	# Create a tmp tree
	mkdir -p $(TREE)/tmp
	# Only dpkg needs this stuff, so it can be removed later.
	mkdir -p $(DPKGDIR)/updates/
	touch $(DPKGDIR)/available

ifdef TRANSSTATUS
	# Include translation status file; warn if older than 2 weeks.
	# Do this first to make possible warnings more visible.
	@echo; \
	if [ -f "$(TRANSSTATUS)" ]; then \
		if [ "$(USE_PROPOSED_UPDATES)" != 1 ]; then \
			olddate=$$(grep "^# Generated on:" $(TRANSSTATUS) | sed "s/.*: //"); \
			if [ "$$olddate" ]; then \
				if [ $$(( $$(date -u "+%s") - \
				          $$(date -d "$$olddate" "+%s") \
				       )) -gt 1209600 ]; then \
					echo "WARNING: The data in '$(TRANSSTATUS)' is older than 2 weeks."; \
					echo "         Should it maybe be updated?"; \
					sleep 15; \
				fi; \
			else \
				echo "WARNING: no timestamp found in $(TRANSSTATUS)."; \
				sleep 15; \
			fi; \
		fi; \
		mkdir -p $(TREE)/usr/share/localechooser; \
		cp $(TRANSSTATUS) $(TREE)/usr/share/localechooser/translation-status; \
	else \
		echo "WARNING: the file $(TRANSSTATUS) does not exist."; \
		sleep 5; \
	fi
endif

	# Unpack the udebs with dpkg. This command must run as root
	# or fakeroot.
	echo -n > $(TEMP)/diskusage.txt
	set -e; \
	oldsize=0; oldblocks=0; oldcount=0; for udeb in $(UDEBDIR)/*.udeb ; do \
		if [ -f "$$udeb" ]; then \
			pkg=`basename $$udeb` ; \
			$(EATMYDATA) dpkg $(DPKG_UNPACK_OPTIONS) --path-include='*' --log=/dev/null --root=$(TREE) --unpack $$udeb ; \
			newsize=`du -bs $(TREE) | awk '{print $$1}'` ; \
			newblocks=`du -s $(TREE) | awk '{print $$1}'` ; \
			newcount=`find $(TREE) -type f | wc -l | awk '{print $$1}'` ; \
			usedsize=`echo $$newsize - $$oldsize | bc`; \
			usedblocks=`echo $$newblocks - $$oldblocks | bc`; \
			usedcount=`echo $$newcount - $$oldcount | bc`; \
			version=`dpkg-deb --info $$udeb | awk '/ Version: / { print $$2 }' | sed 's/+b[0-9]*$$//g'` ; \
			source=`dpkg-deb --info $$udeb | awk '/ Source: / { print $$2 }'` ; \
			if [ -z "$$source" ]; then \
				source=`dpkg-deb --info $$udeb | awk '/ Package: / { print $$2 }'` ; \
			fi ; \
			echo " $$usedsize B - $$usedblocks blocks - $$usedcount files from $$pkg (version $$version)" >>$(TEMP)/diskusage.txt;\

=== debian/changelog ===
debian-installer (20141002) unstable; urgency=low

  [ Samuel Thibault ]
  * Add speech synthesis entries in alternate desktop boot menus.
  * Add keyboard shortcut for Advanced options menu.

  [ Ian Campbell ]
  * Depend on mklibs >= 0.1.40 for ARM EABI fixes relating to the handling
    of__aeabi_* symbols (Closes: #758581).
  * Switch to installing Jessie by default on ARM64.
  * Build netboot mini.iso on ARM64.
  * Build cdrom flavour for ARM64.

  [ Cyril Brulebois ]
  * Deal with even more incompatible changes on the syslinux side by
    adding a syslinux-utils build-dep (Closes: #751731), no thanks to its
    maintainer as far as cooperation is concerned (See: #751724, #759189).
  * Bump linux kernel version from 3.14-2 to 3.16-2.
  * Drop code snippet meant to ensure every checkout would get an updated
    sources.list.udeb (with [trusted=yes]), since that was meant to be
    temporary, and that was almost 2 years ago.
  * Replace ttf-kannada-fonts-udeb with fonts-knda-udeb.
  * Specify -j1 for the submake definition in build/Makefile; that's what
    happens anyway, and warnings go away accordingly.
  * Add fonts-lohit-guru-udeb to gtk images, fixing rendering for Punjabi
    (Closes: #761573).
  * Apply patch from Ron and Chris Kuehl to fix lib location and search
    path for syslinux >= 5. Some constraints include having ldlinux.c32
    in the tftp root, and being able to find some support libraries
    thanks to a defined path (Closes: #756275). Many thanks!
  * Update translation-status for the release.

  [ Frederic Bonnard / Aurelien Jarno ]
  * Add ppc64el support installing sid (Closes: #754093).

  [ Steven Chamberlain ]
  * On kfreebsd and hurd, which use GRUB for PXE booting, request two
    additional modules in the grub-mkimage step: (Closes: #759686)
    - tftp: required since GRUB 2.02 otherwise PXE boot will crash/hang
    - gfxterm_background: required since GRUB 2.02 for the boot splash
      image functionality to be available
    - raise the grub-pc (and indirectly grub-common) build dependency to
      >= 2.02~beta2~ on these architectures, because module
      gfxterm_background did not exist in GRUB 2.00
    - raise the xorriso build dependency to >= 1.3.2-1~ on these
      architectures, for compatibility with grub-mkrescue in GRUB 2.02

  [ Joey Hess ]
  * Remove desktop selection from syslinux; now available in tasksel.
  * remove desktop=xfce preseeding on kfreebsd-* and hurd, since tasksel
    3.27 knows about architecture-specific defaults (Closes: #762614).

  [ Ben Hutchings ]
  * Keep Linux modules.builtin file in the initrd.
  * Update new-kernel-checklist.txt for the last few years' changes.

 -- Cyril Brulebois <kibi@debian.org>  Thu, 02 Oct 2014 08:21:25 +0200

debian-installer (20140802) unstable; urgency=low

  [ Cyril Brulebois ]
  * debian/rules: Introduce build-{arch,indep} targets, depending on
    build-stamp, and depended upon by build.
  * debian/control: Bump Standards-Version to 3.9.5, no further changes
    required.
  * Remove Otavio from Uploaders, with many thanks for his past work.
  * Bump linux kernel version from 3.13-1 to 3.14-1.
  * Adjust and apply patch from Daniel Baumann to deal with incompatible
    changes in syslinux 6 (Closes: #746743):
     - Bump syslinux-common versioned build-dep to >= 3:6
     - Add isolinux and pxelinux build-deps.
     - x86.cfg: Adjust paths to isolinux.bin and pxelinux.0
     - x86.cfg: Adjust path to vesamenu.c32 and add its new dependencies
                (libcom32.c32, libutil.c32, and also ldlinux.c32).
  * Exclude .gitignore files in the dh_installdocs call to avoid spurious
    files when building from a git checkout.
  * Disable translation-status check when proposed-updates is enabled.
    This file isn't going to be updated during stable's lifecycle, so
    avoid pointless warning and sleeping.
  * Update translation-status for the release.

  [ Samuel Thibault ]
  * Add a separate Hurd boot option for CJK support in pseudo-graphical mode, so
    the default can use 720x400 resolution, instead of using 640x400 which is
    not supported by some screens...
  * Pre-configure hurd-libs and libparted.
  * Increase room for udebs on hurd.
  * Remove bogl-bterm-udeb on hurd.

  [ Martin Michlmayr ]
  * Add support for QNAP HS-210.  Thanks to Kevin Woldt for the patch.

  [ Ian Campbell ]
  * Move armmp subarch to toplevel armhf.
  * Ship DTB files for netboot on armhf and armel/kirkwood.
  * Drop version suffix from armhf kernel.

  [ Robert Millan ]
  * Remove kfreebsd-9 and switch to kfreebsd-10 as default (and only)
    option. (Closes: #743292)

  [ Philipe Muškovac ]
  * Use -perm /0111 in Makefile as + is deprecated. Closes: #752009

  [ Colin Watson ]
  * Remove mention of partman's ability to create file systems, check file
    systems, and copy data between partitions, since those all rely on
    libparted's filesystem-handling code which is being removed.

  [ Bastien ROUCARIÈS ]
  * Support for DNS-320. (Closes: #751716)

  [ Ian Campbell ]
  * Bump linux kernel version from 3.14-1 to 3.14-2.

  [ Aurelien Jarno ]
  * Remove fb-modules udebs on mips*/sb1-bcm91250a.
  * Add MIPSEL Loongson 3 images.

 -- Cyril Brulebois <kibi@debian.org>  Sat, 02 Aug 2014 02:59:35 +0200

debian-installer (20140316) unstable; urgency=medium

  [ Colin Watson ]
  * Add SSL_CERTS variable, which can be used to build images with embedded
    SSL certificates with c_rehash run over them so that OpenSSL can see
    them (LP: #833994).

  [ Cyril Brulebois ]
  * build/Makefile: Use $(GZIP) instead of gzip, and prefer pigz over
    gzip if it's available, which can give a nice speed-up.
  * Update boot config/screens for the default desktop change (GNOME → Xfce)
    in tasksel 3.19 (Closes: #738602).
  * Update copyright years in boot screens.
  * Bump linux kernel version from 3.12-1 to 3.13-1.
  * build/config/{amd64,i386}.cfg: Remove old "video=vesa:ywrap,mtrr" option


=== debian/control ===
Source: debian-installer
Section: devel
Priority: optional
Maintainer: Debian Install System Team <debian-boot@lists.debian.org>
Uploaders: Cyril Brulebois <kibi@debian.org>
Standards-Version: 3.9.5
Vcs-Git: git://git.debian.org/d-i/debian-installer.git
Vcs-Browser: http://git.debian.org/?p=d-i/debian-installer.git;a=summary
Build-Conflicts: libnewt-pic [mipsel]
Build-Depends:
# Base build dependencies:
	debhelper (>= 7.0.0),
#		Of course.
	apt (>= 0.8.16),
# 		Used for downloading udebs.
	apt-utils,
# 		apt-ftparchive is used for including localudebs.
	gnupg,
#		New versions of apt need gnupg for security checks.
	debian-archive-keyring (>= 2006.11.22),
#		To provide the archive key for security checks.
	dctrl-tools,
#		Various manipulations of the udeb Packages files.
	wget,
#		Used to test validity of mirrors.
	bc,
#		Used for some image size calculations.
	debiandoc-sgml,
#		partman's manual is in debiandoc.
	xsltproc,
	docbook-xml,
	docbook-xsl,
#		The d-i internals manual is in DocBook XML.
	libbogl-dev,
#		For bdftobogl used in font reduction.
#	
# Library build dependencies:
	glibc-pic,
#		For library reduction.
	libslang2-pic (>= 2.0.6-4),
#		Make dependency versioned temporarily to make sure we avoid #392942
	libnewt-pic (>= 0.52.2-11.3) [!mipsel],
#		Rather than use slang and newt udebs, reduced versions of
#		the libraries are put onto images to save space.
	libnewt-dev (>= 0.52.2-11.3) [mipsel],
#		On mipsel, we can't use libnewt-pic right now due to bug
#		#329733. See also Build-Conflicts above.
	libgcc1 [i386 amd64],
#		On x86 we need to include /lib/libgcc_s.so.1 in g-i initrds to
#		work around #373253 until upstream can remove pthread_cancel()
#		calls in directfb. For now, this is done by setting EXTRAFILES.
# 
# Filesystem tools:
	genext2fs (>= 1.3-7.1),
#		For creating ext2 filesystems without being root.
#		1.3-7.1 fixes issues on several arches.
	e2fsprogs,
#		genext2fs doesn't produce perfect filesystems, so we fsck
#		them.
#		Lintian: Yes, we know it's essential. We prefer not to
#		count on it remaining so.
	mklibs (>= 0.1.40),
#		We use mklibs for library reduction.
	genisoimage [!s390 !s390x],
#		For making mini isos.
	genromfs [sparc sparc64],
#		Used for creating sparc floppies (which are not built by
#		default.)
	hfsutils [powerpc],
#		For making bootable HFS USB sticks for powerpc.
	dosfstools [i386 ia64 m68k amd64 arm64],
#		For creating FAT filesystems with mkfs.msdos.
#		Of course i386/amd64 use this for floppies, CDs etc.
#		ia64 uses it for floppies (?)
#		m68k uses it for atari floppies
	cpio,
#		For creating initramfs images.
	xz-utils,
#		For compressing initramfs images.
	devio [armeb armel],
#		Tool to read and write from block devices, used to byteswap
#		kernels and add nslu2 boot magic.
	slugimage (>= 0.10+r58-6) [armeb armel],
#		For building nslu2 firmware images.
	dns323-firmware-tools (>= 0.3-2) [armel],
#		For building firmware images for the D-Link DNS-32(0|3).
	u-boot-tools [armel armhf],
#		For creating u-boot images
# 
# Boot loaders:
#	On many arches boot loaders are copied onto or ran on the boot
#	images in one way or another. There's a reason our mailing list is
#	still called debian-boot..
	syslinux [i386 amd64],
	syslinux-utils [i386 amd64],
	isolinux [i386 amd64],
	pxelinux [i386 amd64],
	syslinux-common (>= 3:6) [i386 amd64],
#		With isohybrid.
	elilo [ia64],
	yaboot [powerpc],
#		For all our powerpc boot needs. Well, not really.
	aboot (>= 0.9b-2) [alpha],
#		A previous version didn't have netabootwrap.
	silo [sparc],
#		Using silo is problimatic since it needs to run as root,
#		so images that need it are not built by default, but we
#		include it for completeness.
	sparc-utils [sparc sparc64],
#		For elftoaout and piggyback, to make netboot images.
	genisovh [mips],
#		Makes mini iso images bootable on SGI MIPSen.
	tip22 [mips],
#		Piggyback netboot images.
	sibyl [mips mipsel],
# 		For booting the SWARM board.
	atari-bootstrap [m68k],
#		Booting and other tools for Atari systems.
	vmelilo [m68k],
	m68k-vme-tftplilo [m68k],
#		For VME machines, although it doesn't yet support running
#		as non-root, the install will try to use it and fall back
#		to a warning when it fails.
	amiboot [m68k],
#		Bootloader for m68k/amiga machines.
	emile [m68k],
	emile-bootblocks [m68k],
#		Bootloader for m68k/mac machines.
	apex-nslu2 [armeb armel],
#		2nd stage bootloader for Linksys NSLU2.
	grub-efi-amd64-bin [amd64], grub-efi-arm64-bin [arm64], grub-efi-ia32-bin [i386],
	grub-common [amd64 arm64 i386], xorriso,
#		Used to make EFI bootable images
	grub-ieee1275-bin [ppc64el],
#		IEEE1275 bootloader support.
# 
# Architecture specific build dependencies:
	tofrodos [i386 amd64 kfreebsd-i386 kfreebsd-amd64],
#		For todos, used on files that need to be accessible from
#		DOS.
	mtools [i386 ia64 m68k amd64 arm64 kfreebsd-i386 kfreebsd-amd64 hurd-i386],
#		mcopy is used to put files onto FAT filesystems w/o
#		mounting them.
# 
	module-init-tools [linux-any],
#		depmod for 2.6 kernels on the arches that support 2.6.
# 
	bf-utf-source [!s390 !s390x],
#		Contains the unicode font we use. Not a udeb since we
#		perform font reduction at build time.
	mkvmlinuz [powerpc],
#		Used to make powerpc images that can boot direct from
#		firmware w/o using a boot loader.
	openssl,
#		Used to encrypt a firmware image so an ARM based device
#		(Thecus N2100) will accept it. Also useful on other
#		architectures if SSL_CERTS has been set locally.
	win32-loader (>= 0.7.2) [i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386],
#		Alternative boot method for win32 platforms.
	makefs [kfreebsd-any],
#		Used to create an UFS1 filesystem from a directory tree.
	grub-pc (>= 2.02~beta2~) [kfreebsd-i386 kfreebsd-amd64 hurd-i386],
#		Used as the CD-ROM's bootloader
	xorriso (>= 1.3.2-1~) [kfreebsd-i386 kfreebsd-amd64 hurd-i386],
#               Used by grub-pc to create the CD-ROM images
	debian-ports-archive-keyring [sh4 sparc64],
#		Used for architectures hosted on debian-ports.org
	librsvg2-bin [any-amd64 any-i386],
#		Used to convert splash SVG to splash PNG during build

Package: debian-installer
Architecture: any
Built-Using: ${initrd:Built-Using}
Depends: ${misc:Depends}
Description: Debian installer
 This package currently only contains some documentation for the Debian
 installer. We welcome suggestions about what else to put in it.

## debian-installer 20150107

=== debian/changelog ===
debian-installer (20150107) unstable; urgency=medium

  [ Karsten Merker ]
  * Add hd-media support for the armhf platform.

  [ Aurelien Jarno ]
  * Add scsi-modules to the cdrom flavour on ppc64el to be able to access
    the CD-ROM drive.

  [ Steven Chamberlain ]
  * Update kfreebsd (kernel) BASEVERSION to 10.1-0

  [ Ian Campbell ]
  * Add grub.cfg to x86 netboot mini.iso for use on EFI systems
    (Closes: #762618).
  * Use --- as options separator for all Linux command lines. (Closes: #764675)
  * Provide a PXE bootable grub.efi in the netboot flavour for amd64 and arm64.

  [ Cyril Brulebois ]
  * Bump linux kernel version from 3.16-2 to 3.16.0-4.
  * Update (linux) i386 config to pull 586 packages instead of 486 ones,
    since the minimal requirements on i386 (consistency!) have been bumped.
  * Update translation-status for the release.

  [ Samuel Thibault ]
  * Update documentation of required minimum disk size.
  * hurd: Also create /servers/startup

  [ Didier Raboud ]
  * Add Lines boot pictures for x86 Linux, Hurd and kFreeBSD; also make
    these default, add their copyright information in debian/copyright

 -- Cyril Brulebois <kibi@debian.org>  Wed, 07 Jan 2015 04:25:52 +0100

## debian-installer 20150324

=== debian/changelog ===
debian-installer (20150324) unstable; urgency=medium

  [ Didier Raboud ]
  * Correct typo and joy images paths in debian/copyright
  * Use APT `apt-config dump`s result to determine where to find the
    system's sources.list (Closes: #775136)

  [ Raphaël Hertzog ]
  * Bump Build-Depends on dns323-firmware-tools to require version
    0.7.3-1 because d-i uses options that are not supported in the wheezy
    version of the package.

  [ Karsten Merker ]
  * Add boot/arm/u-boot-image-config (a list of u-boot components and their
    offsets on disk, needed to create bootable images for arm-based systems).
  * Provide u-boot binaries for armhf systems without u-boot in flash.
  * Add a workaround for the console baudrate mismatch on some i.MX6-based
    systems in boot/arm/bootscr.mainline_common.

  [ Helge Deller ]
  * alpha: Switch to KERNELVERSION
  * alpha,hppa: add debian-ports gpg keyring

  [ Michael Walle ]
  * Add support for the Buffalo Linkstation LS-CHLv2/LS-XHL (Closes: #744716).

  [ Cyril Brulebois ]
  * Extend write-built-using to also generate the ${extra:Built-Using}
    substvar, making it possible to track packages mentioned in the
    EXTRA_PACKAGES variable (currently set to "bf-utf-source syslinux").
    Thanks to Ansgar Burchardt for the reports (Closes: #696418, #700026).
  * Update translation-status for the release.

 -- Cyril Brulebois <kibi@debian.org>  Tue, 24 Mar 2015 03:25:12 +0100

=== debian/control ===
--- 
+++ 
@@ -82,7 +82,7 @@
 #		kernels and add nslu2 boot magic.
 	slugimage (>= 0.10+r58-6) [armeb armel],
 #		For building nslu2 firmware images.
-	dns323-firmware-tools (>= 0.3-2) [armel],
+	dns323-firmware-tools (>= 0.7.3-1) [armel],
 #		For building firmware images for the D-Link DNS-32(0|3).
 	u-boot-tools [armel armhf],
 #		For creating u-boot images
@@ -133,6 +133,10 @@
 #		Used to make EFI bootable images
 	grub-ieee1275-bin [ppc64el],
 #		IEEE1275 bootloader support.
+	u-boot-imx [armhf],
+	u-boot-omap [armhf],
+	u-boot-sunxi [armhf],
+#		U-boot binaries for armhf systems without u-boot in flash memory
 # 
 # Architecture specific build dependencies:
 	tofrodos [i386 amd64 kfreebsd-i386 kfreebsd-amd64],
@@ -170,7 +174,7 @@
 
 Package: debian-installer
 Architecture: any
-Built-Using: ${initrd:Built-Using}
+Built-Using: ${initrd:Built-Using}, ${extra:Built-Using}
 Depends: ${misc:Depends}
 Description: Debian installer
  This package currently only contains some documentation for the Debian

## debian-installer 20150418

=== debian/changelog ===
debian-installer (20150418) unstable; urgency=medium

  [ Karsten Merker ]
  * Add util/gen-hd-image (a script to create partitioned harddisk images
    from a directory and optionally install a bootloader into the image).
  * Add SD-card image build support for hd-media builds on armhf.
  * Add SD-card image and tftpboot tarball build support for netboot builds
    on armhf.
  * Add u-boot-imx, u-boot-omap and u-boot-sunxi to the "built-using"
    package list.
  * util/gen-hd-image: set proper permissions for the generated partition
    image.
  * Add a symlink boot.scr.uimg -> debian-installer/armhf/tftpboot.scr
    in the armhf netboot.tar.gz to support network autoboot with modern
    u-boot versions.
  * Provide u-boot and SD-card images for the Olimex A20-OLinuXino-MICRO
    and for the LinkSprite pcDuino3 (support for both has been added
    in u-boot 2014.10+dfsg1-5).

  [ Ben Hutchings ]
  * Include fb-modules on powerpc if available (Closes: #782059).

  [ Cyril Brulebois ]
  * Restore shortcuts (install, installspk, expert, menu, etc.) on help
    screens by restoring the menu.cfg include which was probably dropped
    accidentally (Closes: #764154, #781853, #781992), as pointed out by
    Vaclav Ovsik. Thanks!
  * Update translation-status for the release.

 -- Cyril Brulebois <kibi@debian.org>  Sat, 18 Apr 2015 11:39:37 +0200

## debian-installer 20150422

=== debian/changelog ===
debian-installer (20150422) unstable; urgency=medium

  * Update translation-status for the release.

 -- Cyril Brulebois <kibi@debian.org>  Wed, 22 Apr 2015 21:41:38 +0200

=== debian/control ===
--- 
+++ 
@@ -68,11 +68,12 @@
 #		default.)
 	hfsutils [powerpc],
 #		For making bootable HFS USB sticks for powerpc.
-	dosfstools [i386 ia64 m68k amd64 arm64],
+	dosfstools [i386 ia64 m68k amd64 armhf arm64],
 #		For creating FAT filesystems with mkfs.msdos.
 #		Of course i386/amd64 use this for floppies, CDs etc.
 #		ia64 uses it for floppies (?)
 #		m68k uses it for atari floppies
+#		armhf uses it for building bootable SD card images
 	cpio,
 #		For creating initramfs images.
 	xz-utils,
@@ -142,7 +143,7 @@
 	tofrodos [i386 amd64 kfreebsd-i386 kfreebsd-amd64],
 #		For todos, used on files that need to be accessible from
 #		DOS.
-	mtools [i386 ia64 m68k amd64 arm64 kfreebsd-i386 kfreebsd-amd64 hurd-i386],
+	mtools [i386 ia64 m68k amd64 armhf arm64 kfreebsd-i386 kfreebsd-amd64 hurd-i386],
 #		mcopy is used to put files onto FAT filesystems w/o
 #		mounting them.
 #

=== debian/rules ===
#! /usr/bin/make -f

ARCH=$(shell dpkg-architecture -qDEB_BUILD_ARCH)
VERSION=$(shell LC_ALL=C dpkg-parsechangelog | grep ^Version: | cut -d ' ' -f 2)
DATE=$(shell echo $(VERSION) | cut -d '.' -f 1)
SUITE=$(shell LC_ALL=C dpkg-parsechangelog | grep ^Distribution: | cut -d ' ' -f 2)
ifeq (${SUITE},UNRELEASED)
USE_UDEBS_FROM=unstable
TRANSSTATUS=
BOOTMENU_BEEP=n
else
USE_UDEBS_FROM=jessie
USE_PROPOSED_UPDATES=0
TRANSSTATUS=translation-status
BOOTMENU_BEEP=y
endif

ARCHIVEDIR=debian/tmp/installer-$(ARCH)
DESTDIR=$(ARCHIVEDIR)/$(DATE)
IMAGEDIR=$(DESTDIR)/images
TARNAME=debian-installer-images_$(VERSION)_$(ARCH).tar.gz

clean:
	dh_testdir
	dh_testroot
	dh_clean
	$(MAKE) -C build reallyclean
	$(MAKE) -C doc/devel/partman clean
	$(MAKE) -C doc/devel/internals clean

# Must run as root, so is not run as part of regular build.
build-images:
	$(MAKE) -C build all_build stats release \
		USE_UDEBS_FROM=$(USE_UDEBS_FROM) BUILD_DATE=$(DATE) \
		USE_PROPOSED_UPDATES=$(USE_PROPOSED_UPDATES) \
		TRANSSTATUS=$(TRANSSTATUS) BOOTMENU_BEEP=$(BOOTMENU_BEEP)

build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp

build-stamp:
	rm -f $@
	$(MAKE) -C doc/devel/internals
	$(MAKE) -C doc/devel/partman
	touch $@

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	debian/rules build-images

	install -d $(IMAGEDIR)
	cp -a build/dest/* $(IMAGEDIR)
	ln -s $(DATE) $(ARCHIVEDIR)/current

binary-arch: install  
	dh_testdir
	dh_testroot
	dh_installchangelogs
	dh_installdocs doc/* -X Makefile -X build.sh -X .xsl \
		-X internals.xml -X partman-doc.sgml -X .gitignore
	dh_compress
	dh_fixperms

	./build/util/write-built-using

	dh_gencontrol
	dh_md5sums
	dh_builddeb
	cd debian/tmp && tar czvf ../../../$(TARNAME) .
	dpkg-distaddfile $(TARNAME) raw-installer -

binary-indep:

binary: binary-indep binary-arch 
.PHONY: build build-images clean binary-indep binary-arch binary install

## debian-installer 20150422%2bdeb8u4

=== debian/changelog ===
debian-installer (20150422+deb8u4) jessie; urgency=medium

  [ Steve McIntyre ]
  * Add sata-modules for arm64 - some machines do have SATA CD

 -- Cyril Brulebois <kibi@debian.org>  Thu, 02 Jun 2016 01:21:28 +0200

debian-installer (20150422+deb8u3) jessie; urgency=medium

  [ Samuel Thibault ]
  * Add beep to UEFI x86 boot menu (Closes: #796591).
  * Add 's' shortcut for speech to UEFI x86 boot menu.

  [ Steve McIntyre ]
  * Add the part_gpt module into the core grub image to make it easier
    for users doing slightly different things with our images; include
    support for GPT partition tables as well as msdos (Closes: #789600).

  [ Martin Michlmayr ]
  * Exclude usb-serial-modules from the armel network-console image
    since it's not useful there (Closes: #809301).
  * Exclude usb-modules explicitly on armel/orion5x network-console
    to work around bug in util/pkg-list.
  * Drop the file extension from the initrd for QNAP devices.
  * Re-introduce installer images for QNAP TS-x09.
  * Provide u-boot images for plug computers.

  [ Cyril Brulebois ]
  * Adjust p-u support to handle file:// instead of (f|ht)tp:// only,
    thanks to Łukasz Stelmach for both the report and the patch
    (Closes: #803711).

 -- Cyril Brulebois <kibi@debian.org>  Mon, 18 Jan 2016 05:04:12 +0100

debian-installer (20150422+deb8u2) jessie; urgency=medium

  [ Martin Michlmayr ]
  * Add image for Seagate DockStar.
  * Add symlinks for OpenRD variants.
  * Append DTB for LaCie NAS devices that require it.

 -- Cyril Brulebois <kibi@debian.org>  Mon, 31 Aug 2015 21:40:45 +0200

debian-installer (20150422+deb8u1) jessie; urgency=medium

  [ Martin Michlmayr ]
  * Append DTB for SheevaPlug, SheevaPlug eSATA and GuruPlug. (Closes:
    #785588)

  [ Cyril Brulebois ]
  * Enable p-u in debian/rules for the jessie point releases.

 -- Cyril Brulebois <kibi@debian.org>  Thu, 04 Jun 2015 14:07:52 +0200

## debian-installer 20150422+deb8u5

=== debian/changelog ===
debian-installer (20150422+deb8u5) jessie; urgency=medium

  * Bump Linux kernel ABI from 3.16.0-4 to 3.16.0-6

 -- Cyril Brulebois <kibi@debian.org>  Mon, 18 Jun 2018 18:00:16 +0000

=== debian/control ===
--- 
+++ 
@@ -138,6 +138,8 @@
 	u-boot-omap [armhf],
 	u-boot-sunxi [armhf],
 #		U-boot binaries for armhf systems without u-boot in flash memory
+	u-boot [armel],
+#		U-boot binaries for armel systems
 # 
 # Architecture specific build dependencies:
 	tofrodos [i386 amd64 kfreebsd-i386 kfreebsd-amd64],

=== debian/rules ===
--- 
+++ 
@@ -10,7 +10,7 @@
 BOOTMENU_BEEP=n
 else
 USE_UDEBS_FROM=jessie
-USE_PROPOSED_UPDATES=0
+USE_PROPOSED_UPDATES=1
 TRANSSTATUS=translation-status
 BOOTMENU_BEEP=y
 endif
